#!/usr/bin/python1.5
# High Energy Turn script by Defiant <mail@defiant.homedns.org> / Book <BKBen3@gmail.com>
#
# License: GPL - see README
#
# History:
# 0.1 Mod created by Defiant
# 0.2 Updated to work more like HET from SFC/II/OP
# Renamed to HETurn by Book <BKBen3@gmail.com> 01/20/05
# 0.3 Added Sound 03/25/06
#
# Version: 0.3

ManoevreAddFac = 3
EmergTurnTime = 5 # seconds

MODINFO = { "Author": "\"Book\" BKBen3@gmail.com",
            "Download": "http://bcfiles.com/",
            "Version": "0.3",
            "License": "GPL",
            "Description": "High Energy Turn Script"
            }

# Imports
import App
import MissionLib
import Bridge.BridgeUtils
import Lib.LibEngineering
import QuickBattle.QuickBattle

# Vars
pBridge = App.g_kSetManager.GetSet('bridge')
BridgeType = App.BridgeSet_Cast(pBridge).GetConfig()
g_pKiska = App.CharacterClass_GetObject(pBridge, 'Helm')
pKiskaMenu = Bridge.BridgeUtils.GetBridgeMenu('Helm')
EMERG_TURN = App.Mission_GetNextEventType()
ET_EMERG_TURN_TIMER = App.Mission_GetNextEventType()
Save_MaxAngularVelocity = 0
Save_MaxAngularAccel = 0
pButton = None
HETDatabase = App.g_kLocalizationManager.Load("data/TGL/HETurn.tgl")
pNum = 1.5
def EmergTurn(pObject, pEvent):
	global Save_MaxAngularVelocity, Save_MaxAngularAccel, ManoevreAddFac, pButton, EmergTurnTime
	pFail = App.g_kSystemWrapper.GetRandomNumber(2) + 1
	pShip = App.Game_GetCurrentPlayer()
	pHETF = "HETFailed"
	pHETS = "HETSuc"

	if (pShip.GetHull().GetRadius() >= 1):
		pNum = 2
		
	if (pShip.GetImpulseEngineSubsystem() == None):
		print("No Impulse Engines?")
		return
	if (pFail < pNum):
		# Now lets try to damage something
		pSequence = App.TGSequence_Create()
		pSequence.AppendAction(App.CharacterAction_Create(g_pKiska, App.CharacterAction.AT_SAY_LINE, pHETF, None, 0, HETDatabase))
		pSequence.Play()
		pShip.GetHull().SetCondition(pShip.GetHull().GetCondition() - pShip.GetHull().GetMaxCondition() * (App.g_kSystemWrapper.GetRandomNumber(24) + 1) / 100)
		pShip.GetImpulseEngineSubsystem().SetCondition(pShip.GetImpulseEngineSubsystem().GetCondition() - pShip.GetImpulseEngineSubsystem().GetMaxCondition() * (App.g_kSystemWrapper.GetRandomNumber(24) + 1) / 100)
		FindImpulseEngine(pShip)
		pSound = App.TGSound_Create("sfx/BREAKdn.wav", "HETFail", 0)
		pSound.SetSFX(1)
		pSound.SetInterface(0)
		App.g_kSoundManager.PlaySound("HETFail")
		return
		
	pSequence = App.TGSequence_Create()
	pSequence.AppendAction(App.CharacterAction_Create(g_pKiska, App.CharacterAction.AT_SAY_LINE, pHETS, None, 0, HETDatabase))
	pSequence.Play()
	pSound = App.TGSound_Create("sfx/HETwarm.wav", "HETSuc", 0)
	pSound.SetSFX(1)
	pSound.SetInterface(0)
	App.g_kSoundManager.PlaySound("HETSuc")
	# Save
	Save_MaxAngularVelocity = pShip.GetImpulseEngineSubsystem().GetMaxAngularVelocity()
	Save_MaxAngularAccel    = pShip.GetImpulseEngineSubsystem().GetMaxAngularAccel()
	# Change
	pShip.GetImpulseEngineSubsystem().GetProperty().SetMaxAngularVelocity(pShip.GetImpulseEngineSubsystem().GetMaxAngularVelocity() * ManoevreAddFac)
	pShip.GetImpulseEngineSubsystem().GetProperty().SetMaxAngularAccel(pShip.GetImpulseEngineSubsystem().GetMaxAngularAccel() * ManoevreAddFac)

	pButton.SetDisabled()
	
	
	# Create an event - it's a thing that will call this function
	pTimerEvent = App.TGEvent_Create()
	pTimerEvent.SetEventType(ET_EMERG_TURN_TIMER)
	pTimerEvent.SetDestination(App.TopWindow_GetTopWindow())

	SDCounterTime = EmergTurnTime

	# Create a timer - it's a thing that will wait for a given time,then do something
	pTimer = App.TGTimer_Create()
	pTimer.SetTimerStart(App.g_kUtopiaModule.GetGameTime() + SDCounterTime)
	pTimer.SetDelay(0)
	pTimer.SetDuration(0)
	pTimer.SetEvent(pTimerEvent)
	App.g_kTimerManager.AddTimer(pTimer)


def EmergTurnStop(pObject, pEvent):
        global Save_MaxAngularVelocity, Save_MaxAngularAccel, pButton
        
        pShip = App.Game_GetCurrentPlayer()
        
        if (pShip.GetImpulseEngineSubsystem() == None):
            	return
        
        # Change back
        pShip.GetImpulseEngineSubsystem().GetProperty().SetMaxAngularVelocity(Save_MaxAngularVelocity)
        pShip.GetImpulseEngineSubsystem().GetProperty().SetMaxAngularAccel(Save_MaxAngularAccel)
        
        pButton.SetEnabled()
        


# Actually based on MissionLib().FindShuttleBay()
def FindImpulseEngine(pShip):
        pPropSet = pShip.GetPropertySet()
        pEnginePropInstanceList = pPropSet.GetPropertiesByType(App.CT_ENGINE_PROPERTY)
        pEnginePropInstanceList.TGBeginIteration()
        iNumItems = pEnginePropInstanceList.TGGetNumItems()
        pLaunchProperty = None

        for i in range(iNumItems):
                pInstance = pEnginePropInstanceList.TGGetNext()
                pProperty = pShip.GetSubsystemByProperty(App.EngineProperty_Cast(pInstance.GetProperty()))
                if (pProperty != None):
                        pProperty.SetCondition(pProperty.GetCondition() - pProperty.GetMaxCondition() * (App.g_kSystemWrapper.GetRandomNumber(14) + 1) / 100)


        pEnginePropInstanceList.TGDoneIterating()
        pEnginePropInstanceList.TGDestroy() 

App.TopWindow_GetTopWindow().AddPythonFuncHandlerForInstance(ET_EMERG_TURN_TIMER, __name__ + ".EmergTurnStop")
def init():
	global pButton
	pButton =   Lib.LibEngineering.CreateMenuButton("HETurn", "Helm", __name__ + ".EmergTurn")